YssGhoul = CreateFrame("frame")
local YssGhoul = YssGhoul
YssGhoul:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
function YssGhoul:Print(...) ChatFrame1:AddMessage(string.join(" ", "|cFF33FF99YssGhoul|r:", ...)) end
YssGhoul:RegisterEvent("ADDON_LOADED")

local LSM = LibStub("LibSharedMedia-3.0")
LSM:Register("sound", "Explosion", [[Sound\Doodad\Hellfire_Raid_FX_Explosion05.wav]]) -- same as Omens

LibStub("LibSink-2.0"):Embed(YssGhoul)

local L_SG = "Summon Ghoul ASAP!"


function YssGhoul:ADDON_LOADED(event, addon)
	if addon ~= "YssGhoul" then return end
	local _, Class = UnitClass("player")
	if Class == "DEATHKNIGHT" then
		if GetNumTalentTabs() > 0 then self:PLAYER_ALIVE() else self:RegisterEvent("PLAYER_ALIVE") end
	else
		self.PLAYER_ALIVE = nil
		self.CHARACTER_POINTS_CHANGED = nil
		self.OnUpdate = nil
		self.UNIT_PET = nil
	end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
end

function YssGhoul:PLAYER_ALIVE()
	YG_DB = YG_DB or {}
	self.db = YG_DB
	self.db.text = self.db.text or "Summon Ghoul ASAP!"
	self.db.textR = self.db.textR or 1
	self.db.textG = self.db.textG or 0
	self.db.textB = self.db.textB or 0
	self.db.sound = self.db.sound or "Explosion"
	self.db.updateTimer = self.db.updateTimer or 5
	
	self.db.SinkStorage = self.db.SinkStorage or {}
	self:SetSinkStorage(self.db.SinkStorage)
	
	local myOptionsTable = {
		type="group",
		dialogInline  = true,
		args={
			text={
				name="Warning Text",
				desc="Warning text to be displayed when you are not raising your dead!",
				type="input",
				order = 1,
				width = 'full',
				set = function(info,text) YssGhoul.db.text = text end,
				get = function(info) return YssGhoul.db.text end,
			},
			textcolor={
				name="Text Color",
				desc="Select what you want your text color to be",
				type="color",
				order = 10,
				set = function(info,r,g,b) 
					YssGhoul.db.textR = r
					YssGhoul.db.textG = g
					YssGhoul.db.textB = b
				end,
				get = function(info) return YssGhoul.db.textR, YssGhoul.db.textG, YssGhoul.db.textB end,
			},
			sound = {
				name = "Warning Sound",
				desc = "Warning sound to be displayed when you are not raising your dead!",
				type = "select", dialogControl = 'LSM30_Sound',
				order = 20,
				values = AceGUIWidgetLSMlists.sound,
				set = function(info,sound) YssGhoul.db.sound = sound end,
				get = function(info) return YssGhoul.db.sound end,
			},
			updateTimer={
				name="Update Frequency",
				desc="How often do you want to be reminded to resummon your minion?",
				type="range",
				order = 30,
				min = .5,
				max = 30,
				step = .1,
				bigStep = .5,
				set = function(info,val) YssGhoul.db.updateTimer = val end,
				get = function(info) return YssGhoul.db.updateTimer end,
			},
			sinkoptions = self:GetSinkAce3OptionsDataTable(),
		},
	}
	myOptionsTable.args.sinkoptions.inline = true
	myOptionsTable.args.sinkoptions.order = -1
	LibStub("AceConfig-3.0"):RegisterOptionsTable('YssGhoulBlizzOptions', myOptionsTable)
	self.optframe = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YssGhoulBlizzOptions", "YssGhoul")
	self:RegisterEvent("CHARACTER_POINTS_CHANGED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:CHARACTER_POINTS_CHANGED()
	self.PLAYER_ALIVE = nil
end

function YssGhoul:PLAYER_TALENT_UPDATE()
	self:CHARACTER_POINTS_CHANGED()
end

function YssGhoul:CHARACTER_POINTS_CHANGED()
	local name, _, _, _, currentRank = GetTalentInfo(3, 19) -- master of ghoul (need to adjust this with the changing of talents)
	if currentRank > 0 then
		self:RegisterEvent("UNIT_PET")
		self:UNIT_PET(nil, 'player')
	else
		self:UnregisterEvent("UNIT_PET")
		self:SetScript("OnUpdate", nil)
	end
end

local timer = 0
function YssGhoul:OnUpdate(a1)
	timer = timer + a1
	if timer > self.db.updateTimer then
		timer = 0
		if GetSpellCooldown(GetSpellInfo(46584)) ~= 0 or (not HasFullControl()) or UnitInVehicle('player') or HasPetUI() or IsMounted() or UnitOnTaxi("player")  or UnitIsDeadOrGhost("player") then
			self:UNIT_PET(nil,'player')
		else
			PlaySoundFile(LSM:Fetch('sound',self.db.sound))
			self:Pour(self.db.text, self.db.textR, self.db.textG, self.db.textB, nil, 24, "OUTLINE")
		end
	end
end

function YssGhoul:UNIT_PET(event, arg1)
	if arg1 == "player" then
		if HasPetUI() then
			self:SetScript("OnUpdate", nil)
		else
			self:SetScript("OnUpdate", self.OnUpdate)
		end
	end
end
